VERA_LADDR := $9F20
VERA_MADDR := $9F21
VERA_HADDR := $9F22
VERA_DATA0 := $9F23
CHKIN := $FFC6
CLRCHN := $FFCC
MACPTR := $FF44
GETIN := $FFE4
sprite_attr_1 = $70
sprite_attr_2 = $72
R0L=2
R0H=3
R1L=4
R1H=5
R14L=$1E
R14H=$1F
R15L=$20

.org $0700
    ldx #4
	jsr CHKIN
    lda #35
    sta R0L
    wai
    lda R15L
    beq Hipage

   ldx #$36
   ldy #$FE         ; start at sprite 70
   lda #%01001001   ; and decrement
   jsr swapsprites

    stz R15L
    stz VERA_LADDR
    lda #$30
    sta VERA_MADDR
    bra Hiaddr

Hipage:
    ldx #$0E
    ldy #$FC
    lda #%01000001
    jsr swapsprites

    lda #1
    sta R15L
    stz VERA_LADDR
    lda #$53
    sta VERA_MADDR
Hiaddr:
    lda #%00010001
    sta VERA_HADDR
loop1:
	ldx #$23
	ldy #$9F
	lda #$FF
	sec
	jsr MACPTR
	dec R0L
	bne loop1
	ldx #$23
	ldy #$9F
	lda #35
	sec
	jsr MACPTR
	stz VERA_LADDR
	lda #$77
	sta VERA_MADDR
	lda #%00010001
	sta VERA_HADDR
	ldx #$23
	ldy #$9F
	lda #32
	sec
	jsr MACPTR
    jsr CLRCHN
	rts

swapsprites:
          wai
          stx VERA_LADDR
          sty VERA_MADDR
          sta VERA_HADDR

          ldx #35
          ldy #35

          lda #%00001100
sprloop1: sta VERA_DATA0
          dex
          bne sprloop1
sprloop2: stz VERA_DATA0
          dey
          bne sprloop2
          rts






