#CONTROLCODES 1


DoSplash.Screen:
  COLOR 0,0:CLS
  POKE VERA.LOWADDR, 0
  POKE VERA.MIDADDR, $FA
  POKE VERA.HIADDR, %00010001
  POKE R0L, $23
  POKE R0H, $9F
  POKE R1H, $02
  POKE R1L, 0
  POKE A.REG, 0
  SYS MEM.FILL
  SCREEN $80
  BMXFILE$="SPLASH.BMX"
  GOSUB LOADBMX
  GOSUB TestFileSystem
  WAVFILE$="SPLASH.WAV"
  GOSUB Play.Wave.File
RETURN


FILE.NOT.FOUND:
  PRINT "{BELL}":PRINT:PRINT:PRINT:PRINT "{BELL}"
  PRINT "{LIGHT RED}";CHECKFILE$;"{WHT} NOT FOUND !"
  PRINT
  PRINT "PLEASE CHECK YOUR INSTALLATION"
  END

LOADBMX:
     BMX.HDR$=RPT$(32,32)
     OPEN 4,DEVICE,4,BMXFILE$+",S,R"
     POKE X.REG, 4
     SYS CHKIN
     POKE A.REG, 32
## GET A POINTER TO THE BMX.HDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(BMX.HDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     WASERROR = 0
     DOSHOW = 0
     GOSUB PARSEHEADER
     IF BMX.ID$<>"BMX" THEN ERRMSG$= "{RED}"+BMXFILE$+"{WHT} IS NOT A BMX FILE":GOTO ERR.EXIT1
     IF BMX.BITS<>8 THEN ERRMSG$= "{RED}"+STR$(BMX.BITS)+"{WHT} BITS NOT SUPPORTED":GOTO ERR.EXIT1
     IF BMX.VER<>1 THEN ERRMSG$= "{RED}"+BMXFILE$+"{WHT} IS VERSION:{RED}"+STR$(BMX.VER)+"{WHT} NOT SUPPORTED!":GOTO ERR.EXIT1
     IF BMX.WIDTH > 320 THEN ERRMSG$= "{RED}"+STR$(BMX.WIDTH)+"{WHT} WIDTH NOT CURRENTLY SUPPORTED":GOTO ERR.EXIT1
     POKE R0L, FN Lo.Byte(BMX.WIDTH)
     POKE R0H, FN Hi.Byte(BMX.WIDTH)
     POKE R1L, FN Lo.Byte(BMX.HEIGHT)
     POKE R1H, FN Hi.Byte(BMX.HEIGHT)
     POKE R2L, BMX.PALUSED
     POKE R2H, BMX.FIRSTPAL
     BANK BMXLOADERBANK
     SYS $A019
     CLOSE 4
RETURN

ERR.EXIT1:
 SCREEN 1
 PRINT "BMX ERROR: ";ERRMSG$
 CLOSE 4:SYS CLRCHN
 END
ERR.EXIT:
 PRINT:PRINT " ";ERRMSG$:WASERROR=-1:RETURN

PLAY.Wave.File:
   poke R13h, 13
   TextVisible = 0
   F$=WAVFILE$
   GOSUB FILEEXISTS
   IF NOT FE% THEN RETURN
   GOSUB LoadWAVEHeader
   GOSUB ParseRIFFHeader
   IF NOT IsWave THEN RETURN
   UserEnded = 0
   PAUSED = 0
   IF FASTMODE AND (NOT IsHostFS) THEN DOS "U0>B0"
   FillLoopCount = 4
   IF IsHostFS THEN FillLoopCount = 12
   IF BytesPerSecond > 79999 THEN FillLoopCount = FillLoopCount+1
   IF BytesPerSecond > 120000 THEN FillLoopCount = FillLoopCount+1
   IF BytesPerSecond > 120000 AND (FASTMODE AND (NOT IsHostFS)) THEN DOS "U0>B3"
   POKE R13L, TextVisible
   POKE A.REG, FillLoopCount
   POKE X.REG, 6
   POKE R0L, VERA.RATE
   POKE R0H, VERA.CFG OR 13
   POKE R1L, 0
   BANK PLAYERBANK
   TI = SAVETIMER
   SYS StartPCM.Play
RETURN


PARSEHEADER:
  BMX.ID$=LEFT$(BMX.HDR$,3)
  BMX.VER=ASC(MID$(BMX.HDR$,4,1))
  BMX.BITS = ASC(MID$(BMX.HDR$,5,1))
  BMX.VERA.REG=ASC(MID$(BMX.HDR$,6,1))
  BMX.WIDTH = ASC(MID$(BMX.HDR$,7,1)) + (ASC(MID$(BMX.HDR$,8,1))*256)
  BMX.HEIGHT = ASC(MID$(BMX.HDR$,9,1)) + (ASC(MID$(BMX.HDR$,10,1))*256)
  BMX.PALUSED = ASC(MID$(BMX.HDR$,11,1))
  BMX.FIRSTPAL = ASC(MID$(BMX.HDR$,12,1))
  BMX.FILE.OFFSET = ASC(MID$(BMX.HDR$,13,1))+(ASC(MID$(BMX.HDR$,14,1))*256)
  BMX.COMPRESS= ASC(MID$(BMX.HDR$,15,1))
  RETURN

ParseRIFFHeader:
  IsWave = (LEFT$(RIFFHDR$,4) = "RIFF") AND (MID$(RIFFHDR$,9,4)="WAVE")
  PCMBits = ASC(MID$(RIFFHDR$,35,1))
  TMP1 = ASC(MID$(RIFFHDR$,21,1))
  TMP2 = ASC(MID$(RIFFHDR$,22,1))
  NumChannels = ASC(MID$(RIFFHDR$,23,1))
  TMP4 = (TMP1) + (256*TMP2)
  IsPCM = (TMP4=1)
  TMP1 = ASC(MID$(RIFFHDR$,25,1))
  TMP2 = ASC(MID$(RIFFHDR$,26,1)) * 256
  TMP3 = ASC(MID$(RIFFHDR$,27,1)) * 65536
  SampleRate = TMP1+TMP2+TMP3
  VERA.RATE = FN ROUND((SampleRate / 48828.15) * 128)
  IsStereo = (NumChannels=2)
  IsSupported = (IsWave AND (PCMBits=16)) AND IsPCM AND ((NumChannels > 0) AND (NumChannels < 3))
  VERA.CFG=0
  IF NOT IsSupported THEN RETURN
  VERA.CFG = (VERA.CFG OR BIT16.ON)
  IF IsStereo THEN VERA.CFG = (VERA.CFG OR STEREO.ON)
  VERA.CFG = VERA.CFG OR PCM.VOLUME
  BytesPerSecond = ((VERA.RATE/128) * 48828.15)*2
  IF IsStereo THEN BytesPerSecond = BytesPerSecond*2
  BytesPerSecond = FN ROUND(BytesPerSecond)
  RETURN

LoadWAVEHeader:
   RIFFHDR$ = RPT$(44,44)
   OPEN 6,8,6,F$+",S,R"
     POKE X.REG, 6
     SYS CHKIN
     POKE A.REG, 44
## GET A POINTER TO THE WAVEHDR STRING THEN PEEK
## IT FOR THE ADDRESS TO THE STRING DATA
     A=POINTER(RIFFHDR$)+1
     POKE X.REG, PEEK(A)
     POKE Y.REG, PEEK(A+1)
     POKE C.REG, 0
     SYS MACPTR
     SYS CLRCHN
     RETURN


TestFileSystem:
 F$="TESTFILE":GOSUB FILEEXISTS
 IF FE% THEN StartTest
 OPEN 2,8,2,"@:TESTFILE,S,W"
 FOR I = 1 TO 100
     PRINT# 2, "ABCDEFGHIJKLMN"
 NEXT I
 CLOSE 2
StartTest:
 OPEN 2,8,2,"TESTFILE,S,R"
 POKE X.REG,2
 SYS CHKIN
 BANK 62
 POKE X.REG,$00
 POKE Y.REG,$A0
 POKE C.REG, 0
 POKE A.REG, 0
 SYS MACPTR
 IsHostFS = (PEEK(Y.REG) = 1)
 SYS CLRCHN
 CLOSE 2
 RETURN


